> For the complete documentation index, see [llms.txt](https://docs.mindee.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mindee.com/v1/integration/python-sdk/python-api-builder.md).

# Custom API (Deprecated)

{% hint style="warning" %}
**The API Builder product is deprecated.**

We recommend using [Mindee V2](/getting-started/defining-a-model.md), which is much more performant for custom documents.
{% endhint %}

## Quick-Start

```python
from mindee import Client, product

# Init a new client
mindee_client = Client(api_key="my-api-key")

# Add your custom endpoint (document)
my_endpoint = mindee_client.create_endpoint(
    account_name="my-account",
    endpoint_name="my-endpoint",
)

# Load a file from disk
input_source = PathInput("/path/to/the/file.ext")

# Parse the file.
# The endpoint must be specified since it cannot be determined from the class.
result = mindee_client.parse(
    product.CustomV1,
    input_source,
    endpoint=my_endpoint
)

# Print a brief summary of the parsed data
print(result.document)

# Iterate over all the fields in the document
for field_name, field_values in result.document.fields.items():
    print(field_name, "=", field_values)
```

## Custom Endpoints

You may have noticed in the previous step that in order to access a custom build, you will need to provide an account and an endpoint name at the very least.

Although it is optional, the version number should match the latest version of your build in most use-cases.\
If it is not set, it will default to "1".

## Field Types

### Custom Fields

#### List Field

A `ListField` is a special type of custom list that implements the following:

* **confidence** (`float`): the confidence score of the field prediction.
* **reconstructed** (`bool`): indicates whether or not an object was reconstructed (not extracted as the API gave it).
* **values** (`List[`[ListFieldValue](#list-field-value)`]`): list of value fields

Since the inner contents can vary, the value isn't accessed through a property, but rather through the following functions:

* **contents\_list()** (`-> List[Union[str, float]]`): returns a list of values for each element.
* **contents\_string(separator=" ")** (`-> str`): returns a list of concatenated values, with an optional **separator** `str` between them.

  > **Note:** the `str()` method returns a string representation of all values of this object, with an empty space between each of them.

**List Field Value**

Values of `ListField`s are stored in a `ListFieldValue` structure, which is implemented as follows:

* **content** (`str`): extracted content of the prediction
* **confidence** (`float`): the confidence score of the prediction
* **bounding\_box** (`BBox`): 4 relative vertices corrdinates of a rectangle containing the word in the document.
* **polygon** (`Polygon`): vertices of a polygon containing the word.
* **page\_id** (`int`): the ID of the page, is `None` when at document-level.

#### Classification Field

A `ClassificationField` is a special type of custom classification that implements the following:

* **value** (`str`): the value of the classification. Corresponds to one of the values specified during training.
* **confidence** (`float`): the confidence score of the field prediction.

  > **Note:** the `str()` method returns a string representation of all values of this object, with an empty space between each of them.

## Attributes

Custom builds always have access to at least two attributes:

### Fields

**fields** (Dict\[`str`: List[ListField](#list-field)]):

```python
print(str(result.document.inference.prediction.fields["my-field"]))
```

### Classifications

**classifications** (\[`str`: List[ClassificationField](#classification-field)]): The purchase category among predefined classes.

```python
print(str(result.document.inference.prediction.classifications["my-classification"]))
```

## 🧪 Custom Line Items

> **⚠️ Warning**: Custom Line Items are an **experimental** feature, results may vary.

Though not supported directly in the API, sometimes you might need to reconstitute line items by hand.\
The library provides a tool for this very purpose:

### columns\_to\_line\_items()

The **columns\_to\_line\_items()** function can be called from the document and page level prediction objects.

It takes the following arguments:

* **anchor\_names** (`List[str]`): a list of the names of possible anchor (field) candidate for the horizontal placement a line. If all provided anchors are invalid, the `CustomLine` won't be built.
* **field\_names** (`List[str]`): a list of fields to retrieve the values from
* **height\_tolerance** (`float`): Optional, the height tolerance used to build the line. It helps when the height of a line can vary unexpectedly.

Example use:

```python
# document-level
response.document.inference.prediction.columns_to_line_items(
  anchor_names,
  field_names,
  0.011 # optional, defaults to 0.01
)

# page-level
response.document.pages[0].prediction.columns_to_line_items(
    anchor_names,
    field_names,
    0.011 # optional, defaults to 0.01
)
```

It returns a list of [CustomLine](#CustomLine) objects.

### CustomLine

`CustomLine` represents a line as it has been read from column fields. It has the following attributes:

* **row\_number** (`int`): Number of a given line. Starts at 1.
* **fields** (`Dict[str, ListFieldValue]`\[]): List of the fields associated with the line, indexed by their column name.
* **bbox** (`BBox`): Simple bounding box of the current line representing the 4 minimum & maximum coordinates as `float` values.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.mindee.com/v1/integration/python-sdk/python-api-builder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
